package com.vectalis.demo.domain;

import javax.persistence.*;

@Entity
@IdClass(Assignement.PK.class)
public class Assignement
{
	@Id 
	@ManyToOne(cascade = CascadeType.ALL, optional = false)
	private User user;

	public User getUser()
	{
		return user;
	}

	public Project getProject()
	{
		return project;
	}

	@Id
	@ManyToOne(cascade = CascadeType.ALL, optional = false)
	private Project project;
	
	public Assignement(User u, Project p)
	{
		this.user = u;
		this.project = p;
	}
	
	@Embeddable
	public static class PK
	{
		private static final long serialVersionUID = 1L;

		public String user;
		public String project;

		public PK(User user, Project project)
		{
			this.user = user.getCode();
			this.project = project.getCode();
		}

		public String toString()
		{
			return ("(" + user + "::" + project+")");
		}

		public int hashCode()
		{
			return user.hashCode() ^ project.hashCode();
		}

		public boolean equals(Object other)
		{
			if (other != null && (other instanceof PK))
			{
				PK otherPK = (PK) other;
				return this.user.equals(otherPK.user)
						&& this.project.equals(otherPK.project);
			}
			return false;
		}
	}
}
