package com.vectalis.demo.domain;

import static org.junit.Assert.*;

import javax.persistence.EntityManager;

import org.junit.Test;

import com.vectalis.myb2t.EMF;

public class DemoTest
{
	@Test
	public void testDemo()
	{
		EntityManager em = EMF.get().createEntityManager();
		try
		{
			User u1 = new User("u1");
			User u2 = new User("u2");
			Project p1 = new Project("p1");
			Project p2 = new Project("p2");
			
			em.getTransaction().begin();
			em.persist(p1);
			em.persist(p2);
			em.persist(u1);
			em.persist(u2);
			em.persist(new Assignement(u1, p1));
			em.persist(new Assignement(u1, p2));
			em.persist(new Assignement(u2, p1));
			em.getTransaction().commit();
			
			assertNull(u1.getAssignements());
			em.refresh(u1); ///fetch the Assignements collection of u1
			assertNotNull(u1.getAssignements());
			
			int countProjectsAssignedToU1 = u1.getAssignements().keySet().toArray().length; 
			assertEquals(2, countProjectsAssignedToU1);
			
			//prouve that we can access the project p1 through u1.Assignements
			Assignement.PK a11pk = new Assignement.PK(u1, p1);
			Assignement a11 = u1.getAssignements().get(a11pk);
			assertEquals(p1, a11.getProject()); 
		}
		finally
		{
			em.close();
		}
		
	}

}
